(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
    Ce programme permet de visualiser des fichiers DIZ, NFO et TXT.         
                                                                            
 Caractristiques :                                                         
 ------------------                                                         
 - Utilisation de la mmoire XMS, la taille maximale d'un fichier texte sera
   donc la taille de la mmoire vive libre (vous avez des fichiers de 64Mo?)
 - Convertion automatique des caractres Windows au format DOS              
 - Navigation  l'aide des touches flches ou des touches page haut/bas    
 - Support du caractre tabulation (8 espaces)                              
Ĵ
  Version    Consultez le fichier 'UNITE\A-Lire.txt' pour comprendre      
    les caractres dbutant les lignes.                          
                                                                            
 08/08/2000 -> Version 0.4                                                  
    + Mise en couleur des nouveaux paragraphes                              
    + Suppression automatique du caractre 'saut de page'                   
    + Barre d'avancement (ligne et pourcent)                                
 22/03/2000 -> Version 0.3                                                  
    + Utilisation de la mmoire XMS (et l'unit)                            
    + Lecture du nombre de ligne                                            
    * Utilisation relle de l'unit 'TmpFich' (v1.0.0)                      
    * Utilisation d'un tampon mmoire (et non plus la VRAM)                 
    * Pour les fichiers DIZ : une touche suffit pour quitter                
 01/08/1998 -> Version 0.2                                                  
    * Lecture du fichier avec la procdure 'LitLigneFichier'                
    * Utilisation de l'unit 'TmpFich'                                      
 12/08/1998 -> Version 0.1 (premiers essais)                                
 11/07/1998 -> Version 0.0 (cration)                                       
Ĵ
  Facults futures                                                        
                                                        
                                                                            
 Attention "future" signifit "en cours de dveloppement" mais ce dvelop-   
 pement peut tre trs long ou ne jamais aboutir. Si vous pouvez m'aider   
 ajouter ces facults, envoyez moi un email : haypo@ifrance.com.            
                                                                            
 * Convertion complte des caractres Windows au format Dos.                
*)

{$M 4096,0,32000: 32000 octets pour le tampon de lecture dans le fichier }

{$DEFINE VSyncOff: Pas de syncronisation avec l'cran                       }

uses
  Clavier,
  Convert,
  DrvSouri,
  EcranTxt,
  GestFich,
  PolicTxt,
  OptVideo,
  StopProg,
  TmpFich,
  Xms;

{$I Rom16x8.dos : Police de caractre 8x8 pixels DOS }
{$I Rom16x8.win : Police de caractre 8x8 pixels Windows }

const
  { Programme }
  Version = '0.4';
  Email   = 'haypo@ifrance.com';
  PageWeb = 'http://www.haypo.fr.st/';

  { Caractre Windows  dtecter (lettres accentues) }
  CaractWinDetectable = [''{},''{},''{},''{},''{},''{},
                         ''{oe},''{''},''{''},''{''},''{''},
                         ''{<<},''{>>},''{ majuscule}];

  { Caractre nul }
  CaractNul = [' ',#0,#255];

  { Couleurs }
  _CoulFond    = 0;            { Couleur du fond du programme }
  _CoulCdrDIZ  = 15+1*16;      { Cadre des fichiers DIZ }
  _CoulTxtDIZ  = 14+2*16;      { Texte des fichiers DIZ }
  _CoulTxtNFO  = 11+1*16;      { Texte des fichiers NFO }

  _CaractRetourLg = '';      { Retour  la ligne }
  _CoulRetourLg = 15+2*16;

  _CoulNvLigne = 14+2*16;
  _CoulCommentOn  = 15+7*16;
  _CoulCommentOff =  0+8*16;

  { Format DIZ ou NFO ? }
  _FichierC   = 0;
  _FichierDiz = 1;
  _FichierNfo = 2;

  LargDizMax = 70;
  HautDizMax = 23;

  TailleFichMax = 20000000; { 10 Mga-octets : Taille maximale d'un fichier }

var
  NomFich,txt: String;

  { Information sur le format }
  InfoFich: record
    Format: byte;                      { Format DIZ ou NFO ?                 }
    CaractWin: Boolean;                { Le fichier contient des caractres  }
                                       { Windows  convertir ?               }
    Larg,Haut: Word;                   { Dimension du cadre du fichier       }
  end;

  { Souris }
  SourisActive: Boolean;               { Utilise la souris                   }

  { Affichage du fichier }
  TmpL: LongInt;
  i,index,vram: LongInt;
  iy: LongInt;
  ch: char;
  TxtCoupe: String;                    { Si la ligne est plus longue que 80  }
                                       { caractre, coupe la fin (aprs le   }
                                       { dernier espace) et la remet au dbut}
                                       { de la ligne suivante                }
  { Tampon texte }
  LigneVram: array[0..159] of byte;
  TamponTexte: Word;
  OfstEcran,OfstEcranMax: LongInt;
  NbrLigne: LongInt;

procedure Fin; begin
  { Reinitialise le mode texte }
  InitModeTxt;

  { Libre le tampon fichier }
  FinTamponFich;

  { Ferme le fichier }
  Close (FichTmp);

  { Libre le tampon vram }
  if TamponTexte<>0 then RendMemXms (TamponTexte);

  { Affiche le texte d'adieu }
  EcriTc ('LireTexte',15+1*16); EcriTc (' v',7+1*16); EcriTcr (Version,14+1*16);
  EcriT ('Crateur: '); EcriTcr ('Haypo ',10);
  EcriT ('Email   : '); EcriTcr (Email,10);
  EcriT ('Sources : '); EcriTcr (PageWeb,10);
  SauteLigne; CurseurOn;
  Halt;
end;

procedure AttendActionUtilisateur; begin with Souris do begin
  if SourisActive then begin
    repeat LitSouris until TouchPresse or B1 or B2;

    if TouchPresse then LitTouche
    else if B1 then AttendBoutonSouris (1)
    else if B2 then AttendBoutonSouris (2);
  end else begin
    repeat until TouchPresse;

    LitTouche;
  end;
end end;

procedure TestErreurXms (Quand: String); begin
  if ErreurXms=0 then exit;

  EffaceEcranTxt;
  EcriTr ('Erreur lors de '+Quand+' (n'+Hex8z(ErreurXms)+') :');
  EcriTr ('> '+TxtErreurXms);
  EcriTr ('');
  EcriTr ('Info pour le deboggage :');
  with CopieXms do begin
    Ecrit ('Taille = '); EcriTncr (Taille,10);
    Ecrit ('SrcHdl = '); EcriTncr (SrcHdl,10);
    Ecrit ('SrcOfs = '); EcriTnc (SrcOfs,10);
    Ecrit (' ('); EcriTc (Hex16z(SrcOfs shr 16)+':'+Hex16z(SrcOfs and $FFFF),10); EcriTr (')');
    Ecrit ('DstHdl = '); EcriTncr (DstHdl,10);
    Ecrit ('DstOfs = '); EcriTnc (DstOfs,10);
    Ecrit (' ('); EcriTc (Hex16z(DstOfs shr 16)+':'+Hex16z(DstOfs and $FFFF),10); EcriTr (')');
    Ecrit ('Mmoire XMS libre = '); EcriTnc (MemXmsLibre,10); EcriTr (' Ko');
  end;
  Ecrit ('- Pressez une touche pour finir -'); AttendActionUtilisateur;
  EcriTxhc (0,EcranY,80,' ',7); PosX (0);
  RendMemXms (TamponTexte);
  Halt (1);
end;

procedure LitLigneFich; var TmpC: char; begin
  txt := TxtCoupe;
  i := length(txt);
  repeat
    inc (i);
    txt[i] := Chr(LitOctetTmpFich);

    { Caractre tabulation }
    if txt[i]=#9 then begin
      Txt[i] := ' ';
      while (i and 7<>0) and (i<80) do begin
        inc(i);
        Txt[i] := ' ';
      end;
    end;
  until TamponFich.Fin     { Fin du fichier atteinte ?                       }
  or (txt[i]=#13)          { Caractre de retour  la ligne (#13) trouv ?   }
  or (txt[i]=#10)          { Caractre de fin de ligne (#10) trouv ?        }
  or (80<=i);               { Coupe la ligne si elle dpasse 80 caractres    }

  { Caractre de retour  la ligne trouv : il est toujours suivit du        }
  { caractre de fin de ligne (#13#10)                                       }
  if (txt[i]=#13) then begin
    dec (i);
    if (not TamponFich.Fin) then TmpC := chr(LitOctetTmpFich);
  end;

  { Texte au format UNIX (fin de ligne = #10,#10 : supprime le deuxime #10 }
  if (txt[i]=#10) then dec (i);

  { La ligne a plus de 80 caractres }
  if 80<=i then begin
    { Cherche le dernier espace (20 caractres max pour le dernier mot) }
    index := i;
    while (not (txt[index] in CaractNul)) and (60<index) do dec(index);
    if index=60 then index := 80;

    { Si le dernier espace n'est pas le dernier caractre coupe la fin du }
    { texte dans 'TxtCoupe'                                               }
    if index<i then begin
      Move (txt[index+1],TxtCoupe[1],i-index);
      TxtCoupe[0] := chr(i-index);
      dec (i,length(TxtCoupe));
    end;
    TxtCoupe := #0+TxtCoupe;
  end else TxtCoupe := '';

  { Sauve la longueur du texte (sans le caractre de retour  la ligne }
  txt[0] := chr(i);
end;

procedure AfficheFichierDiz; var X,Y: byte; begin with InfoFich do begin
  { Dessine un double cadre }
  DessineCadre (-1,-1,Larg+2,Haut+2,_DOUBLE,_CoulCdrDIZ);
  X := EcranX; Y := EcranY;

  { Rajoute une belle bordure si le texte est petit }
  if (larg<80-5*2) and (haut<25-5*2) then begin
    CoulTxt := _CoulCdrDIZ;
    EcriTx (X-1,Y-4,'');         EcriTx (X+Larg,Y-4,'');
    EcriTx (X-1,Y+Haut+3,'');    EcriTx (X+Larg,Y+Haut+3,'');
    EcriTx (X-1,Y-3,':');         EcriTx (X+Larg,Y-3,':');
    EcriTx (X-1,Y+Haut+2,':');    EcriTx (X+Larg,Y+Haut+2,':');
    EcriTx (X-1,Y-2,'');         EcriTx (X+Larg,Y-2,'');
    EcriTx (X-1,Y+Haut+1,'');    EcriTx (X+Larg,Y+Haut+1,'');
    EcriTx (X-6,Y-1,' ');    EcriTx (X+Larg,Y-1,' ');
    EcriTx (X-6,Y+Haut,' '); EcriTx (X+Larg,Y+Haut,' ');
    CoulTxt := 7+0*16;
  end;

  { Affiche le texte }
  repeat
    LitLigneFich;
    while length(txt)<larg do txt := txt+' ';
    EcriTxc (X,Y,txt,_CoulTxtDIZ);
    inc (Y);
  until TamponFich.Fin;

  AttendActionUtilisateur;
end end;

procedure AfficheTamponTexte; begin
  with CopieXms do begin
    Taille := 24*80*2;
    SrcHdl := TamponTexte;
    SrcOfs := OfstEcran;
    DstHdl := 0;
    DstOfs := $B8000000;
  end;
{$IFNDEF VSyncOff}
  AttendEcran;
{$ENDIF}
  CopieMemXms (CopieXms);
  TestErreurXms ('l''affichage du tampon texte');

  { Si le texte tient sur un cran : cassos }
  if NbrLigne<25 then exit;

  { Sinon, affiche la position actuelle du texte }
  PosXY (0,24);
  EcriThc (LongInt(OfstEcran)*80 div OfstEcranMax,' ',_CoulCommentOn);
  if EcranY<>25 then EcriThc (80-EcranX,' ',_CoulCommentOff);
  PosYr (-1);

  Write ('Ligne : ',1+OfstEcran div 160,'/',NbrLigne);
  Write (' (',LongInt(OfstEcran)*100 div OfstEcranMax,'%)');
end;

procedure DeplaceTexteNFO (Plus: LongInt); begin
  TmpL := OfstEcran +Plus;
  if TmpL<0 then TmpL := 0;
  if OfstEcranMax<TmpL then TmpL := OfstEcranMax;

  if TmpL=OfstEcran then exit;
  OfstEcran := TmpL;

  AfficheTamponTexte;
end;

procedure AfficheFichierNfo; var SauveTxt: String; begin
  Clignotement (FALSE);

  { Prpare la couleur dans la ligne tampon }
  index := 1;
  for i := 0 to 79 do begin
    LigneVram[index] := _CoulTxtNFO;
    inc (index,2);
  end;

  { Ecrit le fichier dans la mmoire texte }
  vram := 0; iy := 0; Txt := #0;
  repeat
    { Lit une ligne de texte }
    SauveTxt := Txt;
    LitLigneFich;

    { Caractre de saut de page : le remplace par une ligne vierge }
    if txt=#12 then txt := '';

    { Cre une ligne de texte dans 'LigneVram' }
    index := 0;
    if (SauveTxt='') and (txt<>'') then begin
      { Ecrit les caractres nuls de la couleur normale }
      i := 1;
      while (txt[i] in CaractNul) and (i<=length(txt)) do begin
        LigneVram[index] := ord(txt[i]); inc (index);
        LigneVram[index] := _CoulTxtNFO; inc (index);
        inc (i);
      end;

      { Ecrit le texte d'une couleur active }
      while (i<=length(txt)) do begin
        LigneVram[index] := ord(txt[i]); inc (index);
        LigneVram[index] := _CoulNvLigne; inc (index);
        inc (i);
      end;
    end else begin
      { Prpare la couleur dans la ligne tampon }
      index := 1;
      for i := 1 to 80 do begin
        LigneVram[index] := _CoulTxtNFO;
        inc (index,2);
      end;

      { C'est un retour  la ligne ? Si oui, dessine un caractre }
      { pour en information                                       }
      index := 0;
      if txt[1]=#0 then begin
        LigneVram[index] := ord(_CaractRetourLg); inc (index);
        LigneVram[index] := _CoulRetourLg; inc (index);
        i := 2;
      end else i := 1;

      for i := i to Length(txt) do begin
        LigneVram[index] := ord(txt[i]);
        inc (index,2);
      end;
    end;

    while index<160 do begin
      LigneVram[index] := ord(' ');
      inc (index,2);
    end;

    with CopieXms do begin
      Taille := 160;
      SrcHdl := 0;
      SrcOfs := Ptr2Long ( Ptr(Seg(LigneVram),Ofs(LigneVram)) );
      DstHdl := TamponTexte;
      DstOfs := Vram;
    end;
    CopieMemXms (CopieXms);
    TestErreurXms ('la copie d''une ligne de texte dans le tampon');

    inc (iy);
    inc (vram,160);
  until TamponFich.Fin;

  { Calcule la position dans la VRAM maximale }
  NbrLigne := Vram div 160;
  if 4000<=Vram then OfstEcranMax := Vram-4000 else OfstEcranMax := 1;

  { Si le texte tient sur un cran : remplit le reste avec du vide }
  if vram<4000 then begin
    { Prpare la couleur dans la ligne tampon }
    index := 0;
    for i := 1 to 80 do begin
      LigneVram[index] := ord(' ');  inc (index);
      LigneVram[index] := _CoulFond; inc (index);
    end;

    while vram<4000 do begin
      with CopieXms do begin
        Taille := 160;
        SrcHdl := 0;
        SrcOfs := Ptr2Long ( Ptr(Seg(LigneVram),Ofs(LigneVram)) );
        DstHdl := TamponTexte;
        DstOfs := Vram;
      end;
      CopieMemXms (CopieXms);
      TestErreurXms ('la copie d''une ligne de texte dans le tampon');

      inc (vram,160);
    end;
  end;

  { Affiche le tampon }
  OfstEcran := 0;
  AfficheTamponTexte;

  { Texte infrieur  une page ? Ouais -> Attend la pression d'une touche    }
  { puis se casse                                                            }
  if NbrLigne<25 then begin
    AttendActionUtilisateur;
    Exit;
  end;

  { Navigation dans le texte }
  ch := #0;
  repeat
    if TouchPresse then begin
      ch := LitTouche;

      Case ch of
      _Debut   : DeplaceTexteNfo (-OfstEcran);
      _PageHaut: DeplaceTexteNfo (-160*24);
      _Haut    : DeplaceTexteNfo (-160);
      _Bas     : DeplaceTexteNfo (+160);
      _PageBas : DeplaceTexteNfo (+160*24);
      _Fin     : DeplaceTexteNfo (OfstEcranMax-OfstEcran);
      end;
    end else LitSouris;
  until (ch=_ECHAPE) or (ch=_ESPACE) or Souris.B1 or Souris.B2;
end;

procedure AfficheTexte; begin
  { Va au dbut du fichier }
  EffaceEcranChr (' ',_CoulFond); CurseurOff;

  Case InfoFich.Format of
  _FichierDiz: AfficheFichierDiz;
  _FichierNfo: AfficheFichierNfo;
  end;
end;

procedure Init;
var TxtErreur: String[12];
begin
  EffaceEcranTxt;

  { Vrifie la prsence du driver XMS }
  VerifiePresenceXms;

  { Lit le nom de l'image dans le PSP ou le demande }
  NomFich := ParamStr(1);
  if NomFich='' then begin
    EcriTcr ('Entrez le nom du fichier texte que vous voulez lire (entre pour quitter) :',15);
    if (not LitTxt(NomFich,80,15+3*16,14+1*16)) or (NomFich='') then Halt;
    SauteLigne;
  end;

  { Le rpertoire existe ? }
  txt := RepertoireExistant (RepertoireNomFich(NomFich));
  if txt<>'' then begin
    Ecrit ('Le rpertoire '); EcriTc (txt,10); EcriTr (' n''existe pas !');
    SauteLigne;
    Halt (1);
  end;

  { Le fichier existe ? }
  if not FichierExistant(NomFich) then begin
    Ecrit ('Le fichier nomme "'); EcriTc (NomFich,10); EcriTr ('" est introuvable !');
    SauteLigne;
    Halt (1);
  end;

  { Le fichier a une taille nulle ? }
  if TailleFichier(NomFich)=0 then begin
    EcriTc ('Le fichier ',12); EcriTc (NomFich,14); EcriTcr (' a une taille nulle !',12);
    SauteLigne;
    Halt (1);
  end;

  { Ouvre le fichier }
  TestErreurFich (OuvreFichier (FichTmp, _LectureSeule, NomFich, ''),'l''ouverture du fichier',NomFich);

  { Vrifie la taille du fichier }
  if TailleFichMax<FileSize(FichTmp) then begin
    Ecrit ('Les fichiers ayant une taille suprieure  ');
    EcriTnc (TailleFichMax shr 10,10); EcriTr (' Ko ne sont pas supports.');
    SauteLigne;
    Ecrit ('Rq: Ce fichier a une taille d''au moins '); EcriTnc (FileSize(FichTmp) shr 10,10); EcriTr (' Ko.');
    SauteLigne;
    Halt (1);
  end;

  { Initialise la souris }
  SourisActive := (DetectSouris='');
  if SourisActive then InitDriverSouris (80,25);

  { Prpare le tampon }
  InitTamponFich (-1);

  { Cherche la taille du fichier texte (largeur et hauteur) et }
  { cherche des caractres Windows                             }
  with InfoFich do begin
    Larg := 0; Haut := 0;
    repeat
      LitLigneFich;

      { Cherche la longueur maximale }
      if Larg<length(txt) then InfoFich.Larg := length(txt);

      { Le fichier contient des caractres Windows ? }
      for i := 1 to length(txt) do
        if txt[i] in CaractWinDetectable then InfoFich.CaractWin := TRUE;

      { Une ligne de plus }
      inc (Haut);
    until TamponFich.Fin;
  end;
  ReinitTamponFich;

  { Si le texte est un format Windows, alors charge }
  { la police de caractre de windows               }
  if InfoFich.CaractWin then
    ChangePolice16x8 (RomAsciiWin);

  { Dtecte le format de fichier (DIZ/NFO) selon les dimensions du fichier }
  with InfoFich do if (LargDizMax<Larg) or (HautDizMax<Haut) then
    Format := _FichierNFO
  else
    Format := _FichierDIZ;

  { Alloue un tampon texte si le fichier est au format NFO }
  if InfoFich.Format=_FichierNFO then begin
    { Calcule la taille du tampon texte et vrifie }
    { que la mmoire disponnible est suffisante.   }
    TmpL := InfoFich.Haut;
    TmpL := TmpL*160;
    TmpL := TmpL shr 10 +1;
    if MemXmsLibre<TmpL then begin
      Str (TmpL,txt);
      Str (MemXmsLibre,TxtErreur);
      StopProgramInfo ('allocation du tampon mmoire','Fichier texte trop important',
                       txt+' Ko recquis contre '+TxtErreur+' Ko disponnibles');
    end;

    { Alloue le tampon texte }
    TamponTexte := AlloueMemXms (TmpL);
    TestErreurXms ('allocation tampon mmoire XMS');
  end;

  { Aucun texte coup pour l'instant }
  TxtCoupe := '';
end;

begin
  Init;

  AfficheTexte;

  Fin;
end.